function models = calculateHistoricalDecomposition( models, nVars )
    for ii = 1:size(models,2)
        % Historical decomposition
        % transform residual series to structural series
        models(ii).HistDecomp = zeros(size(models(1).res,1),nVars^2);
        for jj = 1:size(models(1).res,1)
            tempSum = zeros(nVars,nVars);
            tempMatrix = zeros(nVars,nVars);
            for kk = 1:jj
                for ll = 1:nVars
                    for mm = 1:nVars
                        tempMatrix(ll,mm) = models(ii).phiStruct(ll,(kk-1)*nVars+mm)*models(ii).structShocks(jj-kk+1,mm)';
                    end
                end
                tempSum = tempSum + tempMatrix;
            end
            models(ii).HistDecomp(jj,:) = reshape(tempSum',[],nVars^2);
        end
    end
end